Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## fr.lip6.kernel
Class Kernel<T>

    java.lang.Object
      fr.lip6.kernel.Kernel<T>

Type Parameters:
  `T` - Type of data from input space

All Implemented Interfaces:
  java.io.Serializable

Direct Known Subclasses:
  CMKernel, DoubleGaussChi1, DoubleGaussChi2, DoubleGaussL2, DoubleLinear, FloatGaussChi2, GeneralizedDoubleLinear, GeneralizedSparseDoubleLinear, IndexDoubleGaussL2, IndexDoubleLinear, IntGaussChi1, IntGaussChi2, IntGaussL2, PowerBagKernel, PowerKernel, SimpleSubListKernel, SparseDoubleGaussChi2, SparseDoubleLinear, SparseGeneralizedSparseDoubleLinear, SPDoubleGaussChi2, SubListKernel, SubListMaxKernel, SubListPowerKernel, ThreadedKernel, ThreadedSumKernel, WeightedSumKernel

    public abstract class Kernel<T>

extends java.lang.Object
implements java.io.Serializable

Base class for kernels

Author:
  dpicard
See Also:
  Serialized Form

Field Summary
`java.lang.String` | `name`

Constructor Summary
`Kernel()`

Method Summary
`double[][]` | `getKernelMatrix(java.util.ArrayList<TrainingSample<T>> e)` return the Gram Matrix of this kernel computed on given samples
`double[][]` | `getNormalizedKernelMatrix(java.util.ArrayList<TrainingSample<T>> e)` return the Gram Matrix of this kernel computed on given samples
`double` | `normalizedValueOf(T t1, T t2)` kernel similarity normalized such that k(t1, t1) = 1
`void` | `setName(java.lang.String n)`
`java.lang.String` | `toString()`
`abstract double` | `valueOf(T t1)` kernel similarity to zero
`abstract double` | `valueOf(T t1, T t2)` compute the kernel similarity between two element of input space

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### name

    public java.lang.String name

Constructor Detail

### Kernel

    public Kernel()

Method Detail

### valueOf

    public abstract double valueOf(T t1,
                                   T t2)

  compute the kernel similarity between two element of input space

  Parameters:
    `t1` - first element
    `t2` - second element
  Returns:
    the kernel value

### valueOf

    public abstract double valueOf(T t1)

  kernel similarity to zero

  Parameters:
    `t1` - the element to compute the similarity to zero

### normalizedValueOf

    public double normalizedValueOf(T t1,
                                    T t2)

  kernel similarity normalized such that k(t1, t1) = 1

  Parameters:
    `t1` - first element
    `t2` - second element
  Returns:
    normalized similarity

### getKernelMatrix

    public double[][] getKernelMatrix(java.util.ArrayList<TrainingSample<T>> e)

  return the Gram Matrix of this kernel computed on given samples

  Parameters:
    `e` -
  Returns:
    double[][] containing similarities in the order of the e.

### getNormalizedKernelMatrix

    public double[][] getNormalizedKernelMatrix(java.util.ArrayList<TrainingSample<T>> e)

  return the Gram Matrix of this kernel computed on given samples

  Parameters:
    `e` -
  Returns:
    double[][] containing similarities in the order of the e.

### setName

    public void setName(java.lang.String n)

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD